const execSync = require("child_process").execSync;

const RUNTIME_ERROR = {
    status: "error",
    message: "An error occured when running the command, please contact the administrator"
}

const UNSUPPORTED_RUNTIME = {
    status: "error", 
    message: "Runtime not supported, check configuration"
}

class Module {
    constructor(name, description, prefix, flavor, entrypoint, version) {
        this.name = name;
        this.description = description;
        this.prefix = prefix;
        this.flavor = flavor;
        this.entrypoint = entrypoint;
        this.version = version;
    }

    run(message) {
        switch(this.flavor) {
            case "node":
                let result = undefined;
                try {
                    result = execSync("node " + this.entrypoint + " '" + message.content + "'");
                } catch (exception) {
                    result = RUNTIME_ERROR;
                }

                return result;
                break;
            default:
                return UNSUPPORTED_RUNTIME;
                break;
        }
    }

}

module.exports = Module;
